/* mysignal.h: */

#if defined(SIG_IGN) && !defined(SIG_ERR)
#define SIG_ERR		((Sigfunc *)-1)
#endif


typedef void Sigfunc(int signo);


Sigfunc *mysignal(int signo, Sigfunc *func);

/* mysignal.c */
#include <signal.h>
/*
#include "mysignal.h"
*/

Sigfunc *mysignal(int signo, Sigfunc *func)
{
	struct sigaction act;
	struct sigaction oact;

	act.sa_handler = func;
	sigemptyset(&act.sa_mask);
	act.sa_flags = 0;
	if (signo == SIGALRM)
	{
#ifdef SA_INTERRUPT
		act.sa_flags |= SA_INTERRUPT;	/* SunOS */
#endif
	}
	else
	{
#ifdef SA_RESTART
		act.sa_flags |= SA_RESTART;	/* SVR4, 4.3+BSD */
#endif
	}
	if (sigaction(signo, &act, &oact) < 0)
		return(SIG_ERR);
	return(oact.sa_handler);
}
