/* Header to my raw tcp/ip routines */
#include <ctype.h>

#include <sys/types.h>
#include <sys/param.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <sys/file.h>
#include <sys/ioctl.h>

#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#ifdef AIX
#ifdef DLPI
#include "dlpi.h"
#endif
#include <netinet/ip_var.h>
#define INLINE
#else
#define INLINE  inline
#endif
#include <netinet/ip_icmp.h>
#include <netinet/tcp.h>

#include <arpa/inet.h>
#include <arpa/telnet.h>

#include <netdb.h>
#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <signal.h>
#include <setjmp.h>
#include <pcap.h>

#ifdef _tcp_header
#define EXTERN
#else
#define EXTERN extern
#endif

/* Raw IP Packet */
#define MAXPACKET       2000	/* max ip packet size */

EXTERN struct opacket {
	struct ip ip;
	char buffer[MAXPACKET];
} outpacket;

EXTERN struct sockaddr whereto;	/* Who to try to reach */
EXTERN int debug;		/* Our debug level */
EXTERN int return_now;		/* For the highjacker to insert data */

EXTERN struct oprobe {
	struct ip ip;
	char data[MAXPACKET];
} our_probe;

EXTERN struct ip *iph;
EXTERN struct tcphdr *tcph;

#ifdef LINUX
#define ip_sum ip_csum
#endif

/* Prototypes */
void send_tcp(struct in_addr, ushort, struct in_addr, ushort,
	      int, char *, int, char *, int, ulong, ulong, char *, int);
void send_source_tcp(struct in_addr, ushort, struct in_addr, ushort, int,
		   long, long, char *, int, int, int, struct in_addr **);
void send_icmp(struct in_addr, struct in_addr, int, char *,
	       u_char, u_char, char *, int);
void send_icmp_unreach( struct in_addr , struct in_addr ,
                        struct in_addr , ushort ,
                        struct in_addr , ushort , u_char );
void resend_ip_packet();

/* Always use it with TH_SYN first and then TH_RST */
void ip_flood(struct in_addr, ushort, struct in_addr, int, ulong);

int check_port(struct in_addr, ushort, struct in_addr);
int check_reach(struct in_addr, struct in_addr);
int check_source_route(struct in_addr, struct in_addr, struct in_addr);

struct tcphdr wait_tcp(struct in_addr, ushort, struct in_addr, ushort, int);
long wait_tcp_anwser(struct in_addr, ushort, struct in_addr, ushort);
void print_tcp_data(int);
void show_tcp_packets(int);

void get_sequence(struct sockaddr_in *, ushort, struct sockaddr_in *, u_long *,
		  u_long *);
ulong hash( ulong *, ulong );

struct hostent *resolve_ip(char *name);
int make_raw_socket();
void close_raw_socket();

int make_pcap_hook();
int set_pcap_filter(char *);

#define send_tcp_simple( to, dport, from, sport , flag, seq, ack, line, len) \
	send_tcp(to, dport, from , sport, 0, 0, 0, 0, flag, seq, ack, line, len)

#define send_icmp_simple( to, from, type, code, line, len) \
        send_icmp(to, from , 0, 0, type, code, line, len)


/* IP Source Route Options */
#define LSRR 0x83
#define SSRR 0x89

#define Fprintf (void)fprintf
#define Sprintf (void)sprintf
#define Printf (void)printf

#define Dprintf if( debug ) (void)fprintf
#define D2printf if( debug >= 2 ) (void)fprintf
#define D3printf if( debug >= 3 ) (void)fprintf

#define FALSE 0
#define TRUE  1

